<?php

/**
 * AdminDepoimento
 * Classe responsavel pelo controle dos produtos
 * @copyrigth 2017, Welton Thierree TagPage
 */
class AdminDepoimento {

    private $Data;
    private $DepId;
    private $Result;
    private $Error;

    //nome da tabela no banco de dados
    const Entidy = "tp_depoimentos";

    public function ExeCreate(array $Data) {
        $this->Data = $Data;
        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ['<b>Atenção ao cadastrar</b> Preencha todos campos', WS_ALERT];
        else:
            $this->setData();
            $this->Create();
        endif;
    }

    public function ExeUpdate($DepId, array $Data) {
        $this->DepId = (int) $DepId;
        $this->Data = $Data;

        if (in_array('', $this->Data)):
            $this->Result = false;
            $this->Error = ['<b>Atenção!</b> Preencha todos os campos. ', WS_ALERT];
        else:
            $this->setData();
            $this->Update();
        endif;
    }

    public function ExeDelete($DepId) {
        $this->DepId = (int) $DepId;

        $Read = new Read;
        $Read->ExeRead(self::Entidy, "WHERE depoimento_id = :prodid", "prodid={$this->DepId}");

        if (!$Read->getResult()):
            $this->Result = false;
            $this->Error = ['Oppss, você tentou remover um depoimento que não existe no sistema!', WS_INFOR];
        else:
            extract($Read->getResult()[0]);

            $Delete = new Delete;
            $Delete->ExeDelete(self::Entidy, "WHERE depoimento_id = :delId", "delId={$this->DepId}");
            $this->Result = true;
            $this->Error = ["A <b>depoimento do {$depoimento_autor}</b> foi removida com sucesso!", WS_ACCEPT];

        endif;
    }

    function getResult() {
        return $this->Result;
    }

    function getError() {
        return $this->Error;
    }

    //Private
    private function setData() {
        $this->Data = array_map('strip_tags', $this->Data);
        $this->Data = array_map('trim', $this->Data);
        //$this->Data['depoimento_nome'] = Check::Name($this->Data['depoimento_titulo']);
        $this->Data['depoimento_data'] = date('Y-m-d H:i:s');
    }

    private function Create() {
        $Create = new Create;
        $Create->ExeCreate(self::Entidy, $this->Data);
        if ($Create->getResult()):
            $this->Result = $Create->getResult();
            $this->Error = ["<b>Sucesso:</b> O depoimento do {$this->Data['depoimento_autor']} foi cadastrado no sistema", WS_ACCEPT];
        endif;
    }

    private function Update() {
        $Update = new Update;
        $Update->ExeUpdate(self::Entidy, $this->Data, "WHERE depoimento_id = :prodid", "prodid={$this->DepId}");
        if ($Update->getResult()):
            $this->Result = true;
            $this->Error = ["<b>Sucesso:</b> O depoimento do {$this->Data['depoimento_autor']} foi atualizado no sistema", WS_ACCEPT];
        endif;
    }

}
